=== debian/changelog ===
ros-bouncy-cartographer (2.1.0-0bionic) bionic; urgency=high

  * Autogenerated, no changelog for this version found in CHANGELOG.rst.

 -- Chris Lalancette <clalancette@openrobotics.org>  Sun, 17 Jun 2018 21:12:19 -0000

ros-bouncy-cartographer (0.3.0-0bionic) bionic; urgency=high

  https://github.com/googlecartographer/cartographer/compare/0.2.0...0.3.0

 -- Chris Lalancette <clalancette@openrobotics.org>  Wed, 22 Nov 2017 23:00:00 -0000

ros-bouncy-cartographer (0.2.0-0bionic) bionic; urgency=high

  https://github.com/googlecartographer/cartographer/compare/0.1.0...0.2.0

 -- Chris Lalancette <clalancette@openrobotics.org>  Sun, 18 Jun 2017 22:00:00 -0000

ros-bouncy-cartographer (0.1.0-0bionic) bionic; urgency=high

  * First unstable development release

 -- Chris Lalancette <clalancette@openrobotics.org>  Wed, 17 May 2017 22:00:00 -0000
